<script type="text/javascript" src="/js/cubix-ui-v1.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-button-v1.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-shadow-v1.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-popup-v3.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-grid-v2.0.source.js"></script>
<script type="text/javascript" src="/js/password-meter.js"></script>

<?= $this->headLink()->prependStylesheet($this->baseUrl() . '/css/passwordmeter.css') ?>

<script type="text/javascript">
	var getFilterParams = function () {
		var uri = new URI('?' + $$('form')[0].toQueryString());
		return uri.get('data');
	};
	Cubix.ready = function () {
		var popup = new Cubix.Popup.Ajax({
			abar: [
				{ caption: 'Save', icon: 'accept', action: Cubix.Popup.Actions.SaveValid },
				{ caption: 'Close', icon: 'cancel', action: Cubix.Popup.Actions.Close }
			],
			width: 650
		});
		
		popup.addEvent('loaded', function () {
			$('country').addEvent('change', function() {
				var country = this;

				$('city').set('disabled', 'disabled');
				new Request({
					url: '<?= $this->baseUrl() ?>/geography/cities/ajax-get-cities-grouped?country_id=' + this.get('value'),
					method: 'get',
					onSuccess: function (resp) {
						$('city').set('html', resp);
						$('city').set('disabled', '');
					}
				}).send();
			});
		});
		
		 var menu = new ActionsMenu([
			{ name: 'edit', icon: 'edit', caption: 'Edit', func: function (data) {
				popup.setTitle('Edit Member ' + data.username);
				popup.load('<?= $this->baseUrl() ?>/members/edit?id=' + data.id, function () {
					this.open();
				});
			} },
			{ name: 'remove', icon: 'remove', caption: 'Remove', func: function (data) {
				if ( confirm('Are you sure you want to delete this row?') ) {
					grid.overlay.disable();
					new Request({
						url: '/members/remove?id=' + data.id,
						onSuccess: function (resp) {
							grid.overlay.enable();
							grid.load();
						}.bind(this)
					}).send();
				}
			} },
		], { icon: 'edit', mode: 'mouse' });

		menu.addEvent('show', function (data) {
			this.actions['edit'].enable();
			this.actions['remove'].enable();
		});

		var grid = Cubix.Grid.Instance = new Cubix.Grid('cx-grid', {
			preload: true,
			identifier: { field: 'id' },
			header: [
				{ title: '<input type="checkbox" id="select-all" />', field: '', type: 'Checkbox', width: '15px' },
				{ title: 'ID', field: 'id', type: 'number', sortable: true, width: '50px' },
				{ title: 'Username', field: 'username', type: 'UserName', sortable: true },
				{ title: 'Email', field: 'email', type: 'string', sortable: true },
				{ title: 'Status', field: 'status', type: 'string', sortable: false },
			],
			sort: {
				field: 'id',
				dir: 'desc'
			},
			actions: [
				{ 
					type: 'edit', mouseenter: function (data, btn) {
						menu.show(btn, data);
					}
				} 
			],
			data: new Cubix.Grid.Loader({ url: '/members/data', params: getFilterParams })
		});
		
		grid.addEvent('loaded', function () {
		
			$('select-all').set('checked', '');
			$('select-all').addEvent('click', function() {
				if ( this.get('checked') )
				{
					$$('#cx-grid input[type=checkbox]').each(function(it){
						if ( it.get('id') != 'select-all' )
							it.set('checked', 'checked');
					});
				}
				else
				{
					$$('#cx-grid input[type=checkbox]').each(function(it){
						if ( it.get('id') != 'select-all' )
							it.set('checked', '');
					});
				}
			});
			
			$$('.username').addEvent('click', function (e) {
			e.stop();
			
			var data = this.getParent('tr').rowData;
			
			popup.setTitle('Edit Member ' + data.username);
				popup.load('<?= $this->baseUrl() ?>/members/edit?id=' + data.id, function () {
					this.open();
				});
			});
		});
		
		
		new Cubix.Button($('btn-create'), { onClick: function () {
			popup.setTitle('Add Member'),
			popup.load('<?= $this->baseUrl() ?>/members/create', popup.open);
		}, icon: 'add', caption: 'Add Member' });

		new Cubix.Button($('btn-refresh'), { onClick: function () {
			grid.load();
		}, icon: 'refresh', caption: 'Search', classes: '' });

		var clearForm = function() {
			var inputs = $$('.c-filter-form')[0].getElements('input');

			inputs.each(function(input) {
				var input_type = input.get('type');
				if ( input_type != 'hidden' ) {
					if ( input_type == 'text' ) {
						input.set('value', '');
					}
					else {
						input.set('checked', '');
					}
				}
			});

			var selects = $$('.c-filter-form')[0].getElements('select');

			selects.each(function(select) {
				select.set('value', '');
			});
		};
		
		var initFormSubmit = function() {
			var inputs = $$('.c-filter-form')[0].getElements('input');

			inputs.each(function(input) {
				var input_type = input.get('type');

				if ( input_type != 'hidden' ) {
					if ( input_type == 'text' ) {
						input.addEvent('keyup', function(event) {
							if( event.key == 'enter' ) {
								grid.load();
							}
						});
					}
					else {
						input.addEvent('change', function(){
							grid.load();
						});
					}
				}
			});

			var selects = $$('.c-filter-form')[0].getElements('select');

			selects.addEvent('change', function(){
				grid.load();
			});
		};

		new Cubix.Button($('btn-reset'), { onClick: function () {
			clearForm();
			grid.load();
		}, icon: 'undo', caption: 'Reset Form', classes: 'ml20' });
	
		
		initFormSubmit();
	}
</script>
<div class="form-common gray c-filter-form">
	<form>
		<fieldset class="inner mb10">
			<legend>Personal</legend>
			
			<div class="inner">
				<label for="user_id">ID</label>
				<input id="user_id" type="text" class="txt w8" name="user_id" value="<?= $this->filter_params['user_id'] ?>" />
			</div>
			
			<div class="inner">
				<label for="username">Username</label>
				<input id="username" type="text" class="txt w18" name="username" value="<?= $this->filter_params['username'] ?>" />
			</div>
			<div class="inner">
				<label for="email">Email</label>
				<input id="email" type="text" class="txt w18" name="email" value="<?= $this->filter_params['email'] ?>" />
			</div>	
			<div class="clear"></div>
		</fieldset>
		<fieldset class="inner mb10">
			<legend>Status</legend>
			<div class="inner">
				<label for="f-status">Status</label>
				<?= $this->selectBox('status', 'f-status', $this->defines['user_status_options'], 'w16', $this->filter_params['status'], 'any') ?>
			</div>
		</fieldset>		
		<div class="clear"></div>
		
		<a id="btn-refresh"></a>
		<a id="btn-reset"></a>
		<div class="clear"></div>
	</form>
</div><!-- form-common -->

<div class="mt10 fleft">
	<a id="btn-create"></a>
	<a id="btn-activate"></a>
	<a id="btn-disable"></a>
	<a id="btn-delete"></a>
	<a id="btn-multi-comment"></a>
	<div class="clear"></div>
</div>

<div id="grid-show-count" class="fleft"><span></span> - Members Found</div>
<div class="clear"></div>

<div id="ajax-dest">
	<div id="cx-grid">
	</div>
</div>